/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
var FullStochasticOscillatorIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(FullStochasticOscillatorIndicator, _super);
    function FullStochasticOscillatorIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 3;
        return _this;
    }
    FullStochasticOscillatorIndicator.prototype.get_qc = function () {
        return new FullStochasticOscillatorIndicatorStrategy();
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.get_qp = function () {
        return FullStochasticOscillatorIndicator.$;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.q2));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.q2, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.qi = function () {
        return this.qx;
    };
    FullStochasticOscillatorIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "smoothingPeriod", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.q3));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.q3, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.qk = function () {
        return this.smoothingPeriod;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qz", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.q4));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.q4, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.qh = function () {
        return this.qz;
    };
    FullStochasticOscillatorIndicator.prototype.ps = function () {
        return this.qz;
    };
    FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    FullStochasticOscillatorIndicator.q2 = StrategyBasedIndicator.qu(14, FullStochasticOscillatorIndicator.$);
    FullStochasticOscillatorIndicator.q3 = StrategyBasedIndicator.qv(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
    FullStochasticOscillatorIndicator.q4 = StrategyBasedIndicator.qv(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
    return FullStochasticOscillatorIndicator;
}(StrategyBasedIndicator));
export { FullStochasticOscillatorIndicator };
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map