import { EnumeratorWrapper } from "igniteui-angular-core";
/**
 * Represents a column that is calculated based on the values of other columns.
*/
var IgxCalculatedColumn = /** @class */ (function () {
    function IgxCalculatedColumn() {
    }
    Object.defineProperty(IgxCalculatedColumn.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxCalculatedColumn.prototype.onImplementationCreated = function () {
    };
    IgxCalculatedColumn.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    IgxCalculatedColumn.prototype[Symbol.iterator] = function () {
        return new EnumeratorWrapper(this.i.getEnumerator());
    };
    return IgxCalculatedColumn;
}());
export { IgxCalculatedColumn };
//# sourceMappingURL=igx-calculated-column.js.map