import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { PriceDisplayType } from "./PriceDisplayType";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Pool$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected bf(): SeriesView;
    iu(a: SeriesView): void;
    pj: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    p3: Brush;
    static readonly pt: DependencyProperty;
    trendLineThickness: number;
    p6: PenLineCap;
    p5: DoubleCollection;
    trendLinePeriod: number;
    pn: number;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    pk: PriceDisplayType;
    protected bd(): SeriesHitTestMode;
    lu(a: Point): Rect;
    private pi;
    ak(a: Point): Rect[];
    dh(a: Point, b: boolean): boolean;
    protected dk(a: Point, b: boolean): boolean;
    protected iz(a: any, b: string, c: any, d: any): void;
    private ps;
    an(a: Axis): AxisRange;
    ao(): AxisRange;
    eh(): number;
    c9(a: any): boolean;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    oz(a: CategoryFrame, b: FinancialSeriesView): void;
    hv(a: boolean, b: SeriesView): void;
    protected get_nc(): boolean;
    o1(a: CategoryFrame, b: FinancialSeriesView): void;
    eg(): number;
    private pr;
    private pl;
    private pq;
    fv(a: any, b: Point): any;
    protected jo(): void;
    protected h4(a: any): void;
    p4: Brush;
    ji(a: Brush, b: Brush): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    static $t: Type;
    protected b0: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b3: Pool$1<Path>;
    cl(): Path;
    protected b6: List$1<Path>;
    cb(a: Path): void;
    cd(a: Path): void;
    cc(a: Path): void;
    protected bv(): FinancialBucketCalculator;
    ap(): void;
    private ck;
    private cj;
    private b1;
    b2: ITrendLineManager;
    readonly b4: boolean;
    ce(): void;
    b8(): void;
    b7(): void;
    ch(): GeometryGroup;
    cg(): GeometryGroup;
    cf(): void;
    protected a8(): void;
    protected a9(): void;
    protected z(a: number): any;
    private ci;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    b9(): void;
    b5: boolean;
    ca(): void;
}
