/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ItemwiseStrategyBasedIndicator } from "./ItemwiseStrategyBasedIndicator";
import { MarketFacilitationIndexIndicatorStrategy } from "./MarketFacilitationIndexIndicatorStrategy";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class MarketFacilitationIndexIndicator extends ItemwiseStrategyBasedIndicator {
    constructor() {
        super();
        this.pk = 1;
    }
    get_qy() {
        return new MarketFacilitationIndexIndicatorStrategy();
    }
    get qy() {
        return this.get_qy();
    }
    get_qp() {
        return MarketFacilitationIndexIndicator.$;
    }
    get qp() {
        return this.get_qp();
    }
}
MarketFacilitationIndexIndicator.$t = markType(MarketFacilitationIndexIndicator, 'MarketFacilitationIndexIndicator', ItemwiseStrategyBasedIndicator.$);
//# sourceMappingURL=MarketFacilitationIndexIndicator.js.map