import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TypeRegistrar } from "igniteui-angular-core";
import { IgxTimeAxisIntervalComponent } from './igx-time-axis-interval-component';
import { TimeAxisInterval } from './TimeAxisInterval';
import { TimeAxisIntervalCollection as TimeAxisIntervalCollection_internal } from './TimeAxisIntervalCollection';
import { IgxTimeAxisIntervalCollection } from './igx-time-axis-interval-collection';
let IgxTimeAxisIntervalModule = class IgxTimeAxisIntervalModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeAxisIntervalComponent", IgxTimeAxisIntervalComponent);
        TypeRegistrar.registerCons("IgxTimeAxisIntervalCollection", IgxTimeAxisIntervalCollection);
        TypeRegistrar.register("TimeAxisInterval", TimeAxisInterval.$type);
        TypeRegistrar.register("TimeAxisIntervalCollection", TimeAxisIntervalCollection_internal.$type);
    }
};
IgxTimeAxisIntervalModule = tslib_1.__decorate([
    NgModule({
        imports: [
            CommonModule,
        ],
        declarations: [
            IgxTimeAxisIntervalComponent
        ],
        exports: [
            IgxTimeAxisIntervalComponent
        ],
        entryComponents: [
            IgxTimeAxisIntervalComponent
        ]
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTimeAxisIntervalModule);
export { IgxTimeAxisIntervalModule };
//# sourceMappingURL=igx-time-axis-interval-module.js.map