import { IList$1, Type } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { NumericScaler } from "./NumericScaler";
import { AxisRange } from "./AxisRange";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { AxisLabelManager } from "./AxisLabelManager";
import { NumericAxisBase } from "./NumericAxisBase";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export declare class PercentChangeYAxis extends NumericYAxis {
    static $t: Type;
    ji(): NumericScaler;
    jb(): AxisRange;
    je(a: AxisLabelManager): NumericAxisRenderer;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class VerticalPercentChangeScaler extends NumericScaler {
    static $t: Type;
    private ad;
    constructor(a: PercentChangeYAxis);
    t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    p(a: number, b: ScalerParams): number;
    q(a: number, b: ScalerParams): number;
}
